#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* for isblank() */
#define __USE_GNU
#include <ctype.h>
#include <unistd.h>
#include <rpc/types.h>

/* putting in /etc/fstab a line like //colargol/cdrom /cdrom smbfs defaults
 * makes mount call /sbin/mount.smbfs and passe it the parameters:
 * //colargol/cdrom /cdrom -o rw,noauto 
 * here is a little program that is intended tyo be placed as /sbin/mount.smbfs
 * and reformats the parameters for smbmount.
 */

int main(int argc, char *argv[])
{
	char params[1024];
	char *p,*q;
	int i;
	int clientname=0, password=0;

	/* //server/share /mountpoint */
	sprintf(params,"/usr/sbin/smbmount %s %s",argv[1],argv[2]);

	for (i=3;i<argc;i++)
	{
		p=argv[i];
		/* -o options */
		if (strncmp(p,"-o ",3)==0)
		{
			p+=3;
			while (p && *p)
			{
				if (strncmp(p,",",1)==0) p++;

				/* options not covered by smbfs */
				if (strncmp(p,"rw",2)==0) p+=2;
				if (strncmp(p,"ro",2)==0) p+=2;
				if (strncmp(p,"noauto",6)==0) p+=6;
				if (strncmp(p,"auto",4)==0) p+=4;
				if (strncmp(p,"defaults",8)==0) p+=8;
				if (strncmp(p,"exec",4)==0) p+=4;
				if (strncmp(p,"noexec",6)==0) p+=6;
				if (strncmp(p,"suid",4)==0) p+=4;
				if (strncmp(p,"nosuid",6)==0) p+=6;
				if (strncmp(p,"dev",3)==0) p+=3;
				if (strncmp(p,"nodev",5)==0) p+=5;
				if (strncmp(p,"sync",4)==0) p+=4;
				if (strncmp(p,"async",5)==0) p+=5;
				if (strncmp(p,"remount",7)==0) p+=7;
				if (strncmp(p,"user",4)==0) p+=4;
				if (strncmp(p,"nouser",6)==0) p+=6;
				if (strncmp(p,"noexec",6)==0) p+=6;
				
				/* smbfs options */
				if (strncmp(p,"port=",5)==0)
				{
					p+=5;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -p ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"max_xmit=",8)==0)
				{
					p+=8;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -m ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"servername=",11)==0)
				{
					p+=11;
					if ((q=strchr(p,',')))
					*q='\0';
					strcat(params," -s ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"clientname=",11)==0)
				{
					p+=11;
					if ((q=strchr(p,',')))
					*q='\0';
					strcat(params," -c ");
					strcat(params,p);
					p+=strlen(p);
					clientname=1;
				}
				if (strncmp(p,"machinename=",12)==0)
				{
					p+=12;
					if ((q=strchr(p,',')))
					*q='\0';
					strcat(params," -I ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"username=",9)==0)
				{
					p+=9;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -U ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"domain=",7)==0)
				{
					p+=7;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -D ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"uid=",4)==0)
				{
					p+=4;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -u ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"gid=",4)==0)
				{
					p+=4;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -g ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"mode=",5)==0)
				{
					p+=5;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -f ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"dirmode=",7)==0)
				{
					p+=7;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -d ");
					strcat(params,p);
					p+=strlen(p);
				}
				if (strncmp(p,"password=",8)==0)
				{
					p+=8;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -P ");
					strcat(params,p);
					p+=strlen(p);
					password=1;
				}
				if (strncmp(p,"noconvpasswd",11)==0)
				{
					p+=11;
					if ((q=strchr(p,',')))
						*q='\0';
					strcat(params," -C");
					p+=strlen(p);
				}
			}
		}
		if (strncmp(p,"-n",2)==0) p+=2;
		if (strncmp(p,"-v",2)==0) p+=2;
		while (isblank(*p)) p++;
	}
	if (!clientname)
	{
		char hostname[MAXHOSTNAMELEN + 1];

		gethostname(hostname, MAXHOSTNAMELEN);

		if ((q=(strchr(hostname,'.')))) *q='\0';
		strcat(params," -c ");
		strcat(params,hostname);
	}
	if (!password)
		strcat(params," -n");

/*	printf(params); */

	system(params);

	return 0;
}
